using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

namespace SocietyGames.SpeechWorkout
{
    public /*abstract*/ partial class ExerciseControl : UserControl, IExercise
    {
        public ExerciseControl()
        {
            InitializeComponent();
        }

        protected void OnCorrectlyAnswered(float ranking)
        {
            if (this.CorrectlyAnswered != null)
            {
                this.CorrectlyAnswered(this, new RankingChangedEventArgs(ranking));
            }
        }

        protected void OnIncorrectlyAnswered(float ranking)
        {
            if (this.IncorrectlyAnswered != null)
            {
                this.IncorrectlyAnswered(this, new RankingChangedEventArgs(ranking));
            }
        }

        protected void OnTaskCompleted(float ranking)
        {
            if (this.TaskCompleted != null)
            {
                this.TaskCompleted(this, new RankingChangedEventArgs(ranking));
            }
        }

        #region IExercise Members

        public /*abstract*/ void Reset(float rank)
        {
        }

        public /*abstract*/ void StartNextTask()
        {
        }

        public Control Control
        {
            get
            {
                return this;
            }
        }

        public event RankingChangedEventHandler CorrectlyAnswered;

        public event RankingChangedEventHandler IncorrectlyAnswered;

        public event RankingChangedEventHandler TaskCompleted;

        #endregion
    }
}
