using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;

namespace SocietyGames.SpeechWorkout
{
    /// <summary>
    /// "Concentration" style matching exercise.
    /// </summary>
    class GenericExercise : IExercise
    {
        float currentRanking;
        int activityCount;
        bool shouldEnd;
        Control control;

        #region IExercise Members

        public string Name
        {
            get
            {
                return "Match";
            }
        }

        public void Start(float ranking)
        {
            this.currentRanking = ranking;
            this.activityCount = 0;
            this.shouldEnd = false;
        }

        public int ActivityCount
        {
            get
            {
                return this.activityCount;
            }
        }

        public event EventHandler ActivityCountChanged;

        public void End()
        {
            this.shouldEnd = true;
        }

        public float Ranking
        {
            get
            {
                return this.currentRanking;
            }
        }

        public event EventHandler ExerciseEnded;

        public System.Windows.Forms.Control Control
        {
            get
            {
                return this.control;
            }
        }

        #endregion
    }
}
