using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;

namespace SocietyGames.SpeechWorkout
{
    /*public interface IExercise
    {
        string Name { get; }        //Name of the exercise
        void Start(float ranking);  //Tells exercise to start at this ranking.
        int ActivityCount { get; }  //How many activities have been completed since Start()
        event EventHandler ActivityCountChanged;
        void End();                 //Tells exercise to end as soon as possible
        float Ranking { get; }      //The current ranking of the player if they were to quit now.
        event EventHandler ExerciseEnded; //Raised when the exercise actually ends
        Control Control { get; }    //The control that's displaying the exercise.
    }*/
    
    public class RankingChangedEventArgs : EventArgs
    {
        float ranking;

        public RankingChangedEventArgs(float ranking)
        {
            this.ranking = ranking;
        }

        public float Ranking
        {
            get
            {
                return this.ranking;
            }
        }
    }

    public delegate void RankingChangedEventHandler(object source, RankingChangedEventArgs eventArgs);

    public interface IExercise
    {
        string Name { get; }                //Name of the exercise
        Control Control { get; }            //Get the control that represents this exercise.
        void Reset(float ranking);             //Tells exercise to clear itself and reset to this rank.
        void StartNextTask();               //Tells exercise to start a new task.
        event RankingChangedEventHandler CorrectlyAnswered;    //User did something correct.
        event RankingChangedEventHandler IncorrectlyAnswered;  //User did something incorrect.
        event RankingChangedEventHandler TaskCompleted;      //User finished some task.        
    }
}
