using System;
using System.Collections.Generic;
using System.Text;

namespace SocietyGames.SpeechWorkout
{
    class Staircase
    {
        int requiredCorrect;
        int requiredWrong;
        int correctCount;
        int wrongCount;

        public Staircase(int requiredCorrect, int requiredWrong)
        {
            if (requiredCorrect <= 0)
            {
                throw new ArgumentOutOfRangeException("requiredCorrect");
            }
            if (requiredWrong <= 0)
            {
                throw new ArgumentOutOfRangeException("requiredWrong");
            }
            this.requiredCorrect = requiredCorrect;
            this.requiredWrong = requiredWrong;
        }

        public int Score(bool wasCorrect)
        {
            if (wasCorrect)
            {
                this.correctCount++;
            }
            else
            {
                this.wrongCount++;
            }
            int returnValue = 0;
            if (this.correctCount + this.wrongCount == this.requiredCorrect + this.requiredWrong)
            {                
                if (this.correctCount >= this.requiredCorrect)
                {
                    returnValue = 1;
                }
                else
                {
                    return returnValue = -1;
                }
                Clear();
            }
            return returnValue;
        }

        public void Clear()
        {
            this.correctCount = 0;
            this.wrongCount = 0;
        }
    }
}
